FUNCTION vs_pickcol, color, STATE = state
   ;;
   ;;
   ;;
   COMMON CCOLOR, xcolors
   
   w_height = 50                                     ;Height of ramp
   siz      = 150
   cur_win = !D.WINDOW

   base = WIDGET_BASE(xoffset=100,yoffset=200,     $ ;offset von links/oben
                      SPACE=10,                    $
                      /COL,                        $
                      TITLE = 'pick colour',       $    
                      /base_align_center)            ;all children are aligned

   base1 = WIDGET_BASE(base,                       $
                       /ROW                        $
                       )  
   IF (!D.NAME NE 'MAC') THEN BEGIN
      show = WIDGET_DRAW(base1,                    $
                         YSIZE=w_height,           $
                         XSIZE=siz,                $
                         /BUTTON_EVENTS,           $
                         /FRAME,                   $
                         UVALUE = 'ramp',          $
                         EXPOSE_EVENTS = 0,        $ 
                         RETAIN = 0                $
                         )
      act = WIDGET_DRAW(base1,                     $
                         YSIZE=w_height,           $
                         XSIZE=w_height,           $
                         /BUTTON_EVENTS,           $
                         UVALUE = 'choice',        $
                         EXPOSE_EVENTS = 0,        $
                         RETAIN = 0,               $                         
                         /FRAME                    $
                        )                   
   ENDIF ELSE BEGIN
      show = WIDGET_DRAW(base1,                    $
                         YSIZE=w_height,           $
                         XSIZE=siz,                $
                         /BUTTON_EVENTS,           $
                         /FRAME,                   $
                         UVALUE = 'ramp',          $ 
                         RETAIN = 1                $
                         )
      act = WIDGET_DRAW(base1,                     $
                         YSIZE=w_height,           $
                         XSIZE=w_height,           $
                         /BUTTON_EVENTS,           $
                         UVALUE = 'choice',        $
                         /FRAME,                   $
                         RETAIN = 1                $                        
                        )                   
   ENDELSE
   base2 = WIDGET_BASE(base,                       $
                      /ROW,                        $
                      /FRAME                       $
                    )

   ctnames = '' & LOADCT, Get_Names = ctnames
   FOR j=0,N_ELEMENTS(ctnames)-1 DO $
      ctnames[j] = STRTRIM(j,2) + ' - ' + ctnames[j]

   ctlist = WIDGET_LIST(base2,                     $
                      VALUE = ctnames,             $
                      UVALUE = 'ct',               $
                      YSIZE = 8,                   $
                      SCR_XSIZE = siz              $
                    )

   WIDGET_CONTROL,base,/REALIZE
   WIDGET_CONTROL,base,/CLEAR_EVENTS

   ;;---------------------------------
   ;; drawing colour ramp
   WIDGET_CONTROL, show, GET_VALUE = show_win & WSET, show_win       
   ramp = BINDGEN(xcolors.ncolors) # REPLICATE(1B, 10)
;   ramp = BYTSCL(ramp, TOP=xcolors.ncolors-1) + xcolors.bottom
   ramp = CONGRID(ramp, siz, w_height, /INTERP)
   TV, ramp 

   ;;---------------------------------
   ;; drawing colour button
   WIDGET_CONTROL, act,  GET_VALUE = act_win  & WSET, act_win
   c = color
   TV, REPLICATE(c,w_height,w_height)

   REPEAT BEGIN
      Event=WIDGET_EVENT(base)
      WIDGET_CONTROL,event.id,GET_UVAL = uval
      IF(uval EQ 'ramp') THEN BEGIN
         c = ramp[event.x,1]
         TV, REPLICATE(c,w_height,w_height)
      ENDIF
      IF(uval EQ 'ct') THEN BEGIN
         LOADCT, event.index,              $ 
                NCOLORS = xcolors.ncolors, $
                BOTTOM  = xcolors.bottom,  $
                /SILENT
         state.color_tbl = event.index
         TVLCT, r, g, b, /GET
         xcolors.r = r(xcolors.bottom:xcolors.top)
         xcolors.g = g(xcolors.bottom:xcolors.top)
         xcolors.b = b(xcolors.bottom:xcolors.top)
         WSET, show_win & TV, ramp
         WSET, act_win  & TV, REPLICATE(c,w_height,w_height)
      ENDIF
   ENDREP UNTIL uval EQ 'choice'

   WIDGET_CONTROL,base,/CLEAR_EVENTS, /DESTROY
   WSET, cur_win
   RETURN, c
END
