PRO vs_readval, state, IMAGE=image
  COMMON vs_block
  ;;
  IF NOT vs_debug THEN on_error, 2
  ;;
  ;; Initialize
  ;;
  PixSize = (*state.result).PixSize
  Xsize = (Size((*state.result).Visib))[1]
  Ysize = (Size((*state.result).Visib))[2]
  
  ;;
  ;; Make GUI
  ;;
  ReadvalBase = Widget_Base(tit='VS Value Reader', col=6)
  ReadvalXtitle = Widget_Label(ReadvalBase, val='X:', font=vs_fonts[1])
  ReadValCancel = Widget_Button(ReadvalBase, val='Finish', font=vs_fonts[1])
  ReadvalX = Widget_Text(ReadvalBase, xsize=8)
  ReadvalYtitle = Widget_Label(ReadvalBase, val='Y:', font=vs_fonts[1])
  ReadvalY = Widget_Text(ReadvalBase, xsize=8)
  ReadValVtitle = Widget_Label(ReadvalBase, val='Value:', font=vs_fonts[1])
  ReadvalV = Widget_Text(ReadvalBase, xsize=12)
  Widget_Control, ReadvalBase, /realize
  Eflag = 0
  Widget_Control, vs_wwid, sens=1 ;turn on display sensitivity
  WHILE NOT Eflag DO BEGIN
      Event = Widget_Event(ReadvalBase, /nowait)
      WinEvent = Widget_Event(vs_wwid, /nowait)
      IF Event.ID EQ ReadValCancel THEN Eflag=1
      IF WinEvent.ID EQ vs_wwid THEN BEGIN
          XC = WinEvent.X
          YC = WinEvent.Y
          CC = convert_coord(XC, YC, /device, /to_data) 
          XC = CC[0] &  YC=CC[1]
          IF keyword_set(image) THEN BEGIN
              XR = XC/PixSize+Xsize/2
              YR = YC/PixSize+Ysize/2
          ENDIF ELSE BEGIN
              XC = round(XC)
              YC = round(YC)
              XR = XC*PixSize*Xsize+Xsize/2
              YR = YC*PixSize*Ysize+Ysize/2
          ENDELSE 
          IF XR GE 0 AND XR LT Xsize AND YR GE 0 AND YR LT Ysize THEN BEGIN 
              IF keyword_set(image) THEN $
                Rval=((*state.result).cube)[XR, YR, state.SelFrame] $
              ELSE $
                Rval=((*state.result).visib)[XR, YR, state.SelFrame]
              Widget_Control, ReadvalV, set_val=string(Rval, format='(g12.5E3)')
          ENDIF 
          Widget_Control, ReadvalX, set_val=string(XC, format='(f8.2)')
          Widget_Control, ReadvalY, set_val=string(YC, format='(f8.2)')
          
      ENDIF 
  ENDWHILE 
  Widget_Control, vs_wwid, sens=0
  Widget_Control, ReadvalBase, /Clear_Events, /Destroy
END
  
